// File for Belle 2 ECS functions for PCIe40
#include "pcie40_b2ecs.h"
#include "pcie40_ecs.h"
#include <stdio.h>

// **************************************************************************
// Status of the b2link: 0 = BAD, 1 = GOOD
// **************************************************************************
int pcie40_b2linkstatus(int dev, int fd) { 
  int ret = 0 ;
  ret = ecs_read( dev , ECS_BAR , ECS_B2LINK_STATUS_ADD ) ;
  return ( ( ret & ( 1 << ( ECS_B2LINK_STATUS_BIT + fd ) ) ) 
	   >> ( ECS_B2LINK_STATUS_BIT + fd ) ) ;
}

// **************************************************************************
// Resynchronize the b2link, returns 1 if success, 0 if error 
// **************************************************************************
int pcie40_resyncb2link(int dev , int fd ) { 
  int ret = 0 ;
  int i ; 
  for ( i = 0 ; i<10 ; i++ ) {
    ret = ecs_write( dev , ECS_BAR , ECS_B2LINK_RESET_ADD , 0x0 ) ;
    if ( 0 != ret ) return 0 ;
    ret = ecs_write( dev , ECS_BAR , ECS_B2LINK_RESET_ADD , 
		     1 << ( ECS_B2LINK_RESET_BIT + fd ) ) ;
    if ( 0 != ret ) return 0 ;
    ret = ecs_write( dev , ECS_BAR , ECS_B2LINK_RESET_ADD , 0x0 ) ;
    if ( 0 != ret ) return 0 ;
    usleep( 1000000 );
    ret = pcie40_b2linkstatus( dev , fd ) ;
    if ( 1 == ret ) return ret ;
  }    

  return 0;
}

