#ifndef PCIE40_B2ECS_H
#define PCIE40_B2ECS_H
// Header file for Belle 2 ECS functions with PCIe40

// Constants
// BAR number for Slow control interface
#define ECS_BAR 2
// Address of the register to reset the write FIFO and bit to use
#define ECS_B2LINK_RESET_ADD 0x00050240
#define ECS_B2LINK_RESET_BIT 0
#define ECS_B2LINK_STATUS_ADD 0x000500E0
#define ECS_B2LINK_STATUS_BIT 0

// Functions to read/write registers and stream files to Front End

/// b2link status (1 = OK, 0= BAD)
int pcie40_b2linkstatus(int dev, int fd);

/// Resynchronize b2link
int pcie40_resyncb2link(int dev, int fd);
#endif // PCIE40_B2ECS_H
